SystemOrganization addCategory: #'Rizel-Core'!
SystemOrganization addCategory: #'Rizel-Core-Tests'!

Object subclass: #RzObject
	instanceVariableNames: 'old new profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

RzObject subclass: #RzClass
	instanceVariableNames: 'methods package superclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzClass methodsFor: 'accessing' stamp: 'JPSA 1/30/2013 16:08'!
>> aSymbol
	^ self rzMethodAt: aSymbol.! !

!RzClass methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 10/11/2012 14:09'!
build
	"merging methods of new and old"
	| names newClasses oldClasses |
	names := IdentitySet new.
	newClasses := self property:#methods from:#new ifAbsent:[OrderedCollection new].
	oldClasses := self property:#methods from:#old ifAbsent:[OrderedCollection new].
	names addAll: (newClasses collect:#selector).
	names addAll: (oldClasses collect:#selector).
	names do: [:name | 
			| a b method|
			b := newClasses select: [:cls | cls selector = name].
			b := b isEmpty ifTrue:[ nil ] ifFalse: [b anyOne].
			a := oldClasses select: [:cls | cls selector = name].
			a := a isEmpty ifTrue:[ nil ] ifFalse: [a anyOne].
			method := RzMethod old: a new: b owner: profile.
			methods add: method.
			method class: self. ].
		! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:05'!
className
	^ self property: #className ifAbsent: [''].! !

!RzClass methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	methods := OrderedCollection new! !

!RzClass methodsFor: 'accessing' stamp: 'JPSA 1/30/2013 16:31'!
localMethodAt: aString
	
	^  self methods detect:  [: cls| cls selector asString  = aString ] ifNone:[nil].! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:03'!
methods
	^ methods! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:51'!
package
	^ package! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:51'!
package: object
	package := object. ! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 10/10/2012 19:17'!
printOn: aStream
	""
	aStream nextPutAll: (self className).! !

!RzClass methodsFor: 'accessing' stamp: 'JPSA 1/30/2013 16:35'!
rzClassName
	^ self property: #className ifAbsent: [''].! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 10/10/2012 17:31'!
superclass
	^  superclass.! !

!RzClass methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 10/10/2012 17:31'!
superclass: rzObjectClass
	superclass := rzObjectClass.! !

RzObject subclass: #RzMethod
	instanceVariableNames: 'outcommingCalls class hasDifferentArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalAlcocer 10/18/2012 20:54'!
allCallingMethods
	"all outgoint call methods"
	|stack list map|
	map := Dictionary new.
	stack := Stack new.
	list := OrderedCollection new.
	"mark as visited"
	map at: self put: true. 
	stack push: self.
	""
	[stack notEmpty] whileTrue: [
		|method|
		method := stack pop.
		"mark as visited"
		map at: method put: true.
		list add: method.
		method callingMethods asSet do:[ :m | 
			|visited|
			visited := map at: m ifAbsent: [false].
			"if not visited"
			visited ifFalse: [ stack push:m].].
	].
	^ list asIdentitySet.! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:31'!
allOutgoingMethods
	"all outgoint call methods"
	|stack list map|
	map := Dictionary new.
	stack := Stack new.
	list := OrderedCollection new.
	"mark as visited"
	map at: self put: true. 
	stack push: self.
	""
	[stack notEmpty] whileTrue: [
		|method|
		method := stack pop.
		"mark as visited"
		map at: method put: true.
		list add: method.
		method outgoingCalls do:[ :m | 
			|visited|
			visited map at: m ifAbsent: false.
			"if not visited"
			visited ifFalse: [ stack push:m].].
	].
	^ list.! !

!RzMethod methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:36'!
browse
	| morph |
	morph := DiffMorph 
					from: (self property:#copySourceCode from: #old ifAbsent: ['']) 
					to: (self property:#copySourceCode from: #new ifAbsent: ['']).
	morph openInWindow.! !

!RzMethod methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:23'!
build
	^ self! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 22:58'!
callerMethods
	"return all incoming calls of this method"
	|result allMethods|
	result := OrderedCollection new.
	new ifNil:[ ^ result].
	new incomingCalls do:[ : nm|
		|set|
		set :=  profile methods select: [ :rm |  rm new == nm].
		set isEmpty ifFalse:[ result add: (set anyOne). ]. ].
	^ result.
	

	! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 22:58'!
callingMethods
	"return all outgoing calls of this method"
	|result allMethods|
	result := OrderedCollection new.
	new ifNil:[ ^ result].
	new outgoingCalls do:[ : nm|
		|set|
		set :=  profile methods select: [ :rm |  rm new == nm].
		set isEmpty ifFalse:[ result add: (set anyOne). ]. ].
	^ result.! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:49'!
class: object
	class := object.! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 17:56'!
hasDifferentByteCode
	(self isNew) ifTrue: [^ false].
	(self wasDeleted) ifTrue: [^ false].
	^ self hasDifferent:#compiledMethod.! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:38'!
hasDifferentSourceCode
	^ self hasDifferent:#copySourceCode.! !

!RzMethod methodsFor: 'rizel' stamp: 'JPSA 1/30/2013 17:31'!
hasSameArguments
	|argsA argsB|
	hasDifferentArguments ifNil: [
		argsA := self property: #cacheArguments from: #old  ifAbsent: [OrderedCollection new].
		argsB := self property: #cacheArguments from: #new  ifAbsent: [OrderedCollection new].
		hasDifferentArguments := ((argsA select:[ :arg |  argsB contains: [ :n | n = arg]]) size = (argsB size)).].
	^ hasDifferentArguments.! !

!RzMethod methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:34'!
initialize 
	super initialize.! !

!RzMethod methodsFor: 'rizel' stamp: 'JPSA 10/25/2012 16:16'!
invokers: aSymbol
	|result|
	result := 0. 

	self callerMethods do: [ :mtd |
		(mtd isNew) ifTrue:[
				result := result + (mtd invokers: aSymbol).
			] ifFalse: [
				result := result + (mtd property:aSymbol from:#old ifAbsent:[0]).
			]
		].
	^ result.! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalAlcocer 9/28/2012 14:22'!
isCovered
	^ self property: #isCovered ifAbsent: [false]. ! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JPSA 1/30/2013 17:13'!
isExecutedMoreThan
	| aTime bTime |
	
	aTime := self property: #numberOfExecutions from: #old ifAbsent: [0].
	bTime := self property: #numberOfExecutions from: #new ifAbsent: [0].
	
	^ bTime > aTime! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalAlcocer 10/18/2012 18:27'!
isFasterThan
	| aTime bTime |
	
	aTime := self property: #numberOfCalls from: #old ifAbsent: [0].
	bTime := self property: #numberOfCalls from: #new ifAbsent: [0].
	
	^ aTime > bTime! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalA 6/24/2012 22:16'!
isNew
	^ old isNil and: [ new isNil not].! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalAlcocer 10/16/2012 15:50'!
isOld
	^ new isNil and: [ old isNil not].! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalAlcocer 10/18/2012 18:26'!
isSlowThan
	| aTime bTime |
	
	aTime := self property: #numberOfCalls from: #old ifAbsent: [0].
	bTime := self property: #numberOfCalls from: #new ifAbsent: [0].
	
	^ bTime > aTime! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalAlcocer 9/28/2012 14:22'!
isTestMethod
	^ self property: #isTestMethod ifAbsent: [false]. ! !

!RzMethod methodsFor: 'accesing' stamp: 'JPSA 10/25/2012 00:58'!
oldCallerMethods
	"return all incoming calls of this method"
	|result|
	result := OrderedCollection new.
	old ifNil:[ ^ result].
	old incomingCalls do:[ : nm|
		|set|
		set :=  profile methods select: [ :rm |  rm old == nm].
		set isEmpty ifFalse:[ result add: (set anyOne). ]. ].
	^ result.
	

	! !

!RzMethod methodsFor: 'print' stamp: 'JuanPabloSandovalAlcocer 12/14/2012 16:03'!
printOn: aStream
	""
	aStream nextPutAll: (self class className);
			  nextPutAll: ('>>');
			  nextPutAll: (self selector).! !

!RzMethod methodsFor: 'print' stamp: 'JPSA 1/30/2013 17:24'!
printPropertiesAsList
	|list|
	list := OrderedCollection new.
	list add: '-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.
	list add: (self rzClass className asString),'>>',(self selector).
	list add: '-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.
	list add: 'Number of Sent Messages'.
	list add: 'Before: ', (self property:#numberOfCalls from:#old ifAbsent:[0]) asString .
	list add: 'After: ', (self property:#numberOfCalls from:#new ifAbsent:[0]) asString .
	list add: '-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.
	list add: 'Number of Executions'.
	list add: 'Before: ', (self property:#numberOfExecutions from:#old ifAbsent:[0]) asString .
	list add: 'After: ', (self property:#numberOfExecutions from:#new ifAbsent:[0]) asString .
	^ list.! !

!RzMethod methodsFor: 'accesing' stamp: 'JPSA 1/30/2013 16:35'!
rzClass
	^ class! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:42'!
selector
	"return the selector name of any new or old version"
	^ self property:#selector.! !

!RzMethod methodsFor: 'rizel-metrics' stamp: 'JuanPabloSandovalA 6/24/2012 22:16'!
wasDeleted
	^ old isNil not and: [ new isNil].! !

!RzMethod methodsFor: 'accesing' stamp: 'JuanPabloSandovalAlcocer 10/18/2012 20:55'!
withAllCallingMethods
	^ (self allCallingMethods) add: self ; asIdentitySet.! !

!RzObject class methodsFor: 'factory' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 21:08'!
old: oldNode new: newNode
	| node |
	node := self new.
	node old: oldNode.
	node new: newNode.
	node profile: self.
	node build.
	^ node! !

!RzObject class methodsFor: 'factory' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 22:58'!
old: oldNode new: newNode owner: rizelObject
	| node |
	node := self new.
	node old: oldNode.
	node new: newNode.
	node profile: rizelObject.
	node build.
	^ node! !

!RzObject methodsFor: 'initialize-release' stamp: ''!
build
	^ self! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 10/18/2012 19:25'!
delta: aSymbolProperty
	| aTime bTime |
	
	aTime := self property: aSymbolProperty from: #old ifAbsent: [0].
	bTime := self property: aSymbolProperty from: #new ifAbsent: [0].
	
	^ (bTime - aTime) abs.! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:55'!
hasDifferent: aSymbol
	"return if has different aSymbol property"
	
	^ (self property: aSymbol from:#old) ~=  (self property: aSymbol from:#new) .! !

!RzObject methodsFor: 'accessing' stamp: ''!
new
	^ new! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:58'!
new: newestNode 
	" newest node"
	new := newestNode! !

!RzObject methodsFor: 'accessing' stamp: ''!
old
	^ old! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:57'!
old: olderNode
	old := olderNode! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 20:55'!
profile
	^  profile.! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 20:55'!
profile: aObject
	 profile:= aObject.! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:05'!
property: aSymbol
	^ self property: aSymbol  ifAbsent: [nil]
		! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:56'!
property: aSymbol from: target
	"return target property"
	^ self property: aSymbol from: target ifAbsent: [ nil ]. ! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 19:56'!
property: aSymbol from: target ifAbsent: aBlock
	"return target property"
	|obj|
	obj := self perform: target.
	obj ifNil: [ ^ aBlock value].
	^ (self perform: target) perform: aSymbol.! !

!RzObject methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:05'!
property: aSymbol ifAbsent: aBlock
	^ self property: aSymbol from:#new ifAbsent:[
		self property: aSymbol from:#old ifAbsent: aBlock
		]! !

RzObject subclass: #RzPackage
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzPackage methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 10/11/2012 14:09'!
build
	"merging classes of new and old"
	| names newClasses oldClasses |
	names := IdentitySet new.
	newClasses := self property:#classes from:#new ifAbsent:[OrderedCollection new].
	oldClasses := self property:#classes from:#old ifAbsent:[OrderedCollection new].
	names addAll: (newClasses collect:#className).
	names addAll: (oldClasses collect:#className).
	names do: [:name | 
			| a b class|
			b := newClasses select: [:cls | cls className = name].
			b := b isEmpty ifTrue:[ nil ] ifFalse: [b anyOne].
			a := oldClasses select: [:cls | cls className = name].
			a := a isEmpty ifTrue:[ nil ] ifFalse: [a anyOne].
			class := RzClass old: a new: b owner: profile.
			classes add: class.
			class package: self. ].! !

!RzPackage methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:07'!
classes
	^ classes.! !

!RzPackage methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	classes := OrderedCollection new! !

!RzPackage methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 20:10'!
methods
	| ms |
	ms := OrderedCollection new.
	self classes do: [:c | ms addAll: c methods].
	^ ms.! !

!RzPackage methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 19:15'!
packageName
	"package Name"
	^ self property:#packageName ifAbsent: [ ''].! !

RzObject subclass: #RzProfile
	instanceVariableNames: 'packages key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core'!

!RzProfile class methodsFor: 'factory' stamp: 'JuanPabloSandovalAlcocer 10/18/2012 20:18'!
merge: profileA with: profileB
	| names newClasses oldClasses packages profile|
	names := IdentitySet new.
	packages := OrderedCollection new.
	newClasses := profileB packages.
	oldClasses := profileA packages.
	names addAll: (newClasses collect:#packageName).
	names addAll: (oldClasses collect:#packageName).
	profile := RzProfile old: profileA new: profileB.
	names do: [:clsName | 
			| a b|
			b := newClasses select: [:cls | cls packageName = clsName].
			b := b isEmpty ifTrue:[ nil ] ifFalse: [b anyOne].
			a := oldClasses select: [:cls | cls packageName = clsName].
			a := a isEmpty ifTrue:[ nil ] ifFalse: [a anyOne].
			packages add: (RzPackage old: a new: b owner: profile)].
	profile packages: packages.
	^ profile.! !

!RzProfile methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 9/28/2012 14:20'!
allCoveredMethods
	^ self methods select: #isCovered.! !

!RzProfile methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:40'!
allMethods
	^ self methods.! !

!RzProfile methodsFor: 'accessing' stamp: 'JPSA 1/30/2013 16:14'!
classAt: aString
	^  self classes detect:  [: cls|  cls className = aString ]
					   ifNone:[nil].! !

!RzProfile methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/10/2012 14:02'!
classes
	|cs|
	cs := OrderedCollection new.
	self packages do:[ :pkg| cs addAll: (pkg classes)].
	^ cs.! !

!RzProfile methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 10/10/2012 17:53'!
computeSuperclasses
	|classes|
	classes := self classes.
	
	classes do:[ :cls | 
		(cls property:#superclass from:#new ifAbsent:[nil]) 
			ifNotNil: [ :sp |
				|scls|
				scls := classes select:[ :c |  (c new = sp) ].
				scls isEmpty ifFalse:[ cls superclass: (scls first). ]. ].  ].! !

!RzProfile methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 6/24/2012 22:17'!
deletedMethods
	^ self methods select:#wasDeleted.! !

!RzProfile methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 22:12'!
key

	^ key! !

!RzProfile methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 22:12'!
key: anObject

	key := anObject! !

!RzProfile methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/10/2012 14:02'!
methods
	|ms|
	ms := OrderedCollection new.
	self classes do:[ :cls| ms addAll: (cls methods)].
	^ ms.! !

!RzProfile methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 6/24/2012 22:15'!
newMethods
	^ self methods select:#isNew.! !

!RzProfile methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:19'!
packages

	^ packages! !

!RzProfile methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/8/2012 22:19'!
packages: anObject

	packages := anObject! !

!RzProfile methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 6/24/2012 23:44'!
testMethods
	^ self methods select: #isTestMethod! !

TestCase subclass: #RzObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core-Tests'!

!RzObjectTest commentStamp: '<historical>' prior: 0!
A RzObjectTest is a test class for testing the behavior of RzObject!

!RzObjectTest methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 17:00'!
buildPendrive
	|pendrive mp3s mp4s texts images|
	pendrive := RSPenDrive new.
	mp3s := RSDirectory new.
	mp3s add: (RSMP3File named:'MP3A' size:10).
	mp3s add: (RSMP3File named:'MP3B' size:10).
	mp3s add: (RSMP3File named:'MP3C' size:10).
	mp3s add: (RSMP3File named:'MP3D' size:10).

	mp3s add: (RSMP3File named:'MP3E' size:10).

	mp3s add: (RSMP3File named:'MP3F' size:10).
	
	mp4s := RSDirectory new.	
	mp4s add: (RSMP3File named:'MP4A' size:10).
	mp4s add: (RSMP3File named:'MP4B' size:10).
	mp4s add: (RSMP3File named:'MP4C' size:10).
	mp4s add: (RSMP3File named:'MP4D' size:10).
	mp4s add: (RSMP3File named:'MP4E' size:10).
	mp4s add: (RSMP3File named:'MP4F' size:10).
	
	texts := RSDirectory new.
	texts add: (RSTextFile named:'TextA' size:10).
	texts add: (RSTextFile named:'TextB' size:10).
	texts add: (RSTextFile named:'TextC' size:10).
	texts add: (RSTextFile named:'TextD' size:10).
	texts add: (RSTextFile named:'TextE' size:10).
	texts add: (RSTextFile named:'TextF' size:10).
	
	images := RSDirectory new.
	images add: (RSImageFile named:'ImageA').
	images add: (RSImageFile named:'ImageB').
	images add: (RSImageFile named:'ImageC').
	images add: (RSImageFile named:'ImageD').
	images add: (RSImageFile named:'ImageE').
	images add: (RSImageFile named:'ImageF').
	
	pendrive add: mp3s.
	pendrive add: mp4s.	
	pendrive add: texts.
	pendrive add: images.
	
	^ pendrive.! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 17:54'!
testEquality
	|profile rzProfile|
	
	profile := RzProfilerSpy profile: [
		self buildPendrive.
		] inClassCategory:'Rizel-Test-Scenario'.
	
	rzProfile := RzProfile merge: profile with: profile.
	
	self assert: (rzProfile newMethods size = 0).
	self assert: (rzProfile deletedMethods size = 0).! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 21:02'!
testHasDifferent
	|obj obj2|
	obj := RzObject old: 4 new: 2.
	obj2 := RzObject old: 2 new:2.
	self assert: (obj hasDifferent:#printString).
	self assert: (obj2 hasDifferent: #printString) not.! !

!RzObjectTest methodsFor: 'testing' stamp: 'JPSA 1/30/2013 17:59'!
testHasSameArguments
	|A B rzProfile|
	A := RzProfilerSpy profile: [
		RSTextFile named:'TextA' size:10.
		] inClassCategory:'Rizel-Test-Scenario'.

	B := RzProfilerSpy profile: [
		RSTextFile named:'TextA' size:15.
		] inClassCategory:'Rizel-Test-Scenario'.
	rzProfile := RzProfile merge: A with: B.
	self assert: (((rzProfile classAt: 'RSFile') localMethodAt: 'size:') hasSameArguments not).
	"self assert: (rzProfile >>#'RSMember'>>#'name:') hasSameArguments."! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 21:07'!
testInitialize
	|robj|
	robj := RzObject old: 4 new: 5.
	
	self assert:( (robj property:#printString from:#old) = '4' ).
	self assert:( (robj property:#printString from:#new) = '5' ).! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 01:20'!
testMerge1
	|A B rzProfile|
	Gofer new
		url:'http://ss3.gemstone.com/ss/Versionner';
		version:'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.1';
		load.
	A := RzProfilerSpy profile: [
		self buildPendrive.
		] inClassCategory:'Rizel-Test-Scenario'.
	Gofer new
		url:'http://ss3.gemstone.com/ss/Versionner';
		version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.2';
		load.
	B := RzProfilerSpy profile: [
		self buildPendrive.
		] inClassCategory:'Rizel-Test-Scenario'.
	rzProfile := RzProfile merge: A with: B.
	self assert: (rzProfile newMethods size = 1).
	self assert: ((rzProfile methods select: #hasDifferentByteCode) size = 2).! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 21:01'!
testNew
	|obj|
	obj := RzObject old: 4 new: 2.
	
	self assert: ((obj property:#printString from:#old) = '4').
	self assert: ((obj property:#printString from:#new) = '2').! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:24'!
testProperties
	|robj robj2 robj3 robj4|
	robj := RzObject old: 4 new: 5.
	robj2 := RzObject old: nil new: 5.
	robj3 := RzObject old: 4 new: nil.
	robj4 := RzObject old: nil new: nil.
	
	self assert:( (robj property:#printString) = '5' ).
	self assert:( (robj2 property:#printString) = '5' ).
	self assert:( (robj3 property:#printString) = '4' ).
	self assert:( (robj4 property:#printString) = nil ).
	self assert:( (robj4 property:#printString ifAbsent:[true]) ).! !
